
function jumpy.init()
common.init()
walljump.init()
weapons.init()
scoreboard.init()
bots.init()

local blooddown = load_particle("blooddown.obj")
local bloodup = load_particle("bloodup.obj")
local bloodleft = load_particle("bloodleft.obj")
local bloodright = load_particle("bloodright.obj")
local gutsound = load_particle("gutsound.obj")
local gutsound2 = load_particle("gutsound2.obj")
local gutsound3 = load_particle("gutsound3.obj")
local dust = load_particle("dustspawn.obj")

local throw = load_particle("throwsound.obj")
local yperitdrawn = load_particle("yperitdrawn.obj")
local yperitskin = load_particle("yperitskin.obj")
local yperitskin2 = load_particle("yperitskin2.obj")
local jdeath = load_particle("jdeath.obj")
local update = load_particle("update.obj")
local frags = 0
local maxfrags = 0
local coughing = 0
local yperit = load_particle("yperit.obj")
local cough = load_particle("cough.obj")
local pierdolonyobject = 0
local shield = load_particle("shield1.obj")
local shield2 = load_particle("shield2.obj")
local kraft = load_particle("kraft.obj")
gametype = 0
fraglimit = 10
gameover = 0
gascount = 0
winnername = 0
winnerposx = 0
winnerposy = 0
gameended = 0
index=0 

gameovermsg = network_game_event("gameovermsg", function(self, data) gameover = 1 end)

fraglimitmsg = network_game_event("fraglimitmsg", function(self, data) fraglimit = data:get_int() end)

suicidecountmsg = network_player_event("suicidecountmsg", function(self, p ,data) p:data().suicides = data:get_int() end)

suicidemsg = network_player_event("suicidemsg", function(self, player, data) player:data().suicidecommited = 1
player:data().msgcounter = 0 player:data().msgcounter2 = 0 player:data().dead = 1 end)

fragmsg = network_player_event("fragmsg", function(self, player, data) player:data().whofragged = data:get_string() end)

fragmsg2 = network_player_event("fragmsg2", function(self, p, data) p:data().msgcounter = 0 p:data().msgcounter2 = 0 p:data().fragged = 1 p:data().killcount = p:data().killcount + 1 end)

madmsg = network_player_event("madmsg", function(self, player, data) weapons.madsend(player) end)

madsend = network_player_event("madsend", function(self, player, data) player:data().ismad = 1 end)



---BINDINGS---

function bindings.wormDeath(worm)

 worm:player():data().shell = 0
 worm:player():data().shell2 = 0
 worm:player():data().railshot = 0
 worm:player():data().karshot = 0
 worm:player():data().gasmeter = 100
 worm:player():data().yperitpress = 0
 worm:player():data().yperitammo = 1
 worm:player():data().dead = 0
 worm:player():data().yperitreloaded = 1
 worm:player():data().killcount = 0
 worm:player():data().madcount = 0
 worm:player():data().ismad = 0
 worm:player():data().kraftpress = 0
 worm:player():data().kraftrelease = 0
 worm:player():data().krafttimer = 0
 worm:player():data().krafttimer2 = 0
 worm:player():data().kraftmana = 100
 worm:player():data().laughcount = 0
 worm:player():data().flamesound = 0
 worm:player():data().hasdjumped = 0
 worm:player():data().hasjumped = 0
 worm:player():data().inair = 0

if gameover == 0 then
worm:shoot(jdeath, 1 , 0)
end
end

function bindings.playerInit(player)
 player:data().shell = 0
 player:data().shell2 = 0
 player:data().railshot = 0
 player:data().karshot = 0
 player:data().gasmeter = 100
 player:data().yperitpress = 0
 player:data().yperitammo = 1
 player:data().suicides = 0
 player:data().dead = 0
 player:data().suicidecommited = 0
 player:data().fragged = 0
 player:data().msgcounter = 0
 player:data().msgcounter2 = 0
 player:data().yperitreloaded = 1
 player:data().whofragged = 0
 player:data().killcount = 0
 player:data().madcount = 0
 player:data().ismad = 0
 player:data().kraftpress = 0
 player:data().kraftrelease = 0
 player:data().krafttimer = 0
 player:data().krafttimer2 = 0
 player:data().kraftmana = 100
 player:data().laughcount = 0
 player:data().flamesound = 0
 player:data().counter = 0
 player:data().timer = 0
 player:data().hasdjumped = 0
 player:data().hasjumped = 0
 player:data().inair = 0
 player:data().scoreboardVisible = false
end


---NET SYNCING---

function jumpy.fraglimitmsg()
if AUTH then
 local a = new_bitstream()
 a:add_int(fraglimit)
 fraglimitmsg:send( a, 0, SendMode.ReliableOrdered, RepRule.Auth2All )
end
end

function jumpy.suicidecountmsg()
if AUTH then
 for p in game_players() do
 local c = new_bitstream()
 c:add_int(p:data().suicides)
 suicidecountmsg:send(p, c, 0, SendMode.ReliableOrdered, RepRule.Auth2All )
end
end
end

function jumpy.fragcheck()
if AUTH then
 if fraglimit > 0 then
 maxfrags = jumpy.fragcount()
end
 local b = new_bitstream()
 if maxfrags >= fraglimit
 and fraglimit > 0
 then
 gameover = 1
 gameovermsg:send( b, 0, SendMode.ReliableOrdered, RepRule.Auth2All )
end
end
end

function jumpy.volume(player)
 local x = 0
 if player:is_local()
  then  x = 120
  else x = 50
 end
return x
end



---FRAG COUNTING ANd GAME ENDING---

function jumpy.fragcount()
 frags = 0
 for p in game_players() do
 if (p:kills()-p:data().suicides) > frags then
 frags = (p:kills()-p:data().suicides)
end
end
 return frags
end

function jumpy.winnername()
 for p in game_players() do
 if (p:kills()-p:data().suicides) >= fraglimit then
 winnername = p:name()
end
end
end

function jumpy.winnerpos()
 for p in game_players() do
 if (p:kills()-p:data().suicides) >= fraglimit then
 winnerposx, winnerposy = p:worm():pos()
end
end
end

function bindings.localplayerEvent(player, key, state)
 if key == Player.Jump and gameover == 1 and state == true
 then return true
end
 if key == Player.Fire and gameover == 1 and state == true
 then return true
end 
 if key == Player.Fire and player:data().ismad == 1
 then return true
end 
 if key == Player.Change and gameover == 1 and state == true
 then return true
end
 if key == Player.Change and player:data().ismad == 1 and state == true
 then return true
end
 if key == Player.Up and gameover == 1 and state == true
 then return true
end 
 if key == Player.Down and gameover == 1 and state == true
 then return true
end
 if key == Player.Left and gameover == 1 and state == true
 then return true
end
 if key == Player.Right and gameover == 1 and state == true
 then return true
end
end

function bindings.playerUpdate(player)
local wx, wy = player:worm():pos()

if AUTH then

 if pierdolonyobject == 0
  then player:worm():shoot(update, 1)
  pierdolonyobject = 1
 end
end

local wsx, wsy = player:worm():spd()

if gameover == 1 then scoreboardVisible = true end

 if gameover == 1 and gameended == 0 then
 gameended = 1
 jumpy.winnerpos()
 jumpy.winnername()

 if player:is_local() and player:name() == winnername then
  local sound = sounds["winner.ogg"]
  local x,y = player:worm():pos()
  sound:play(x, y, 120, 1, 0)
 end

 if player:is_local() and player:name() ~= winnername then
  local sound = sounds["lostmatch.ogg"]
  local x,y = player:worm():pos()
  sound:play(x, y, 120, 1, 0)
 end

elseif gameover == 1
 then player:worm():push(-wsx,-(wsy+0.020))
  if player:name() ~= winnername
  then player:worm():damage(150) player:worm():set_pos( winnerposx, winnerposy )
  else 
    if player:worm():health()<100 then
    player:worm():damage(-(100-player:worm():health()))
    end
  end
end


---MESSAGES---

if player:data().suicidecommited == 1 then
 player:data().msgcounter = player:data().msgcounter + 1
end

if player:data().fragged == 1 then
 player:data().msgcounter2 = player:data().msgcounter2 + 1
end

if player:data().msgcounter >= 255
 then player:data().msgcounter = 0
 player:data().suicidecommited = 0
end

if player:data().msgcounter2 >= 255
 then player:data().msgcounter2 = 0
 player:data().fragged = 0
end

if player:data().msgcounter2 == 1 then
 local x,y = player:worm():pos()
 local v = jumpy.volume(player)

 if player:data().killcount == 3 then
  local sound = sounds["killingspree.ogg"]
  sound:play(x, y, v, 1, 0)
 end

 if player:data().killcount == 5 then
  local sound = sounds["rampage.ogg"]
  sound:play(x, y, v, 1, 0)
 end

 if player:data().killcount == 8 then
  local sound = sounds["dominating.ogg"]
  sound:play(x, y, v, 1, 0)
 end

 if player:data().killcount == 12 then
  local sound = sounds["unstoppable.ogg"]
  sound:play(x, y, v, 1, 0)
 end

 if player:data().killcount == 18 then
  local sound = sounds["godlike.ogg"]
  sound:play(x, y, v+80, 1, 0)
 end

end

if player:data().timer < 70 then
player:data().timer = player:data().timer + 1
else player:data().timer = 0
end

---KRAFT---

if player:data().kraftpress == 1 then
player:worm():shoot(shield, 10 , 0.8, 0, 0.5, 0, 10, 0, 15 )
player:data().krafttimer2 = player:data().krafttimer2 + 1
end

if player:data().kraftrelease == 1 then
player:data().krafttimer = player:data().krafttimer + 1
player:data().krafttimer2 = 0
end

if player:data().krafttimer == 5 then
 player:data().kraftpress = 0
 player:data().kraftrelease = 0
 player:data().krafttimer = 0
end

if player:data().krafttimer2 >= 100 then
if player:data().kraftmana > 0 then
player:worm():shoot(shield, 50 , 0.8, 0, 0, 0, 360, 0, 15 )
player:worm():shoot(shield2, 1 , 0, 0, 0, 0, 0, 0, 0 )
player:data().kraftmana = player:data().kraftmana - 0.12
else player:data().kraftrelease = 1
end
end

if player:data().kraftmana < 100 
and player:worm():current_weapon():type():name() == "Die Kraft" then
player:data().kraftmana = player:data().kraftmana + 0.07
end

if player:data().kraftmana < 0 then
player:data().kraftmana = 0
end

if player:data().krafttimer2 == 140 then
local sound = sounds["shield.ogg"]
local x,y = player:worm():pos()
sound:play(x, y, 100, 1, 0)
player:data().krafttimer2 = 100
end

if player:data().krafttimer2 == 1 then
local sound = sounds["kraftup.ogg"]
local x,y = player:worm():pos()
sound:play(x, y, 60, 1, 0)
end

if player:data().krafttimer2 == 15 then
local sound = sounds["kraftidle.ogg"]
local x,y = player:worm():pos()
sound:play(x, y, 80, 1, 0)
end

if player:data().krafttimer2 == 55 then
local sound = sounds["kraftidle.ogg"]
local x,y = player:worm():pos()
sound:play(x, y, 80, 1, 0)
end

if player:data().krafttimer2 == 95 then
local sound = sounds["kraftidle.ogg"]
local x,y = player:worm():pos()
sound:play(x, y, 80, 1, 0)
end

---JUMPING---

if not map_is_particle_pass(wx, wy + 6) and player:data().inair == 1
then
local wvx, wvy = player:worm():spd()
player:data().inair = 0
if wvy > 1.5 or wvy < -1.5 then
 local sound = sounds["land.ogg"]
 local x,y = player:worm():pos()
 sound:play(x, y, 60, 1, 0.15)
 player:worm():shoot(dust, 5 , 0, 0, 0, 0, 0, 90, 3 )
elseif wvy > 0.2 or wvy < -0.2 then
 local sound = sounds["jump.ogg"]
 local x,y = player:worm():pos()
 sound:play(x, y, 140, 1, 0)
end
end

if map_is_particle_pass(wx, wy + 6)
then player:data().inair = 1
end

if not map_is_particle_pass(wx, wy + 5) or not map_is_particle_pass(wx + 3, wy) or not map_is_particle_pass(wx - 3, wy)
then player:data().hasdjumped = 0
player:data().hasjumped = 0
end

---YPERIT---

 if player:data().gasmeter > 100 and player:data().gasmeter < 240
 then player:data().gasmeter = player:data().gasmeter - 0.2
end
if gameover == 0 then
 if player:data().gasmeter >= 240
 then player:data().gasmeter = player:data().gasmeter - 0.01
end
 if player:data().gasmeter > 235 and player:data().gasmeter < 255
 and coughing == 0 and player:data().ismad == 0
 then player:worm():shoot(cough, 1 , 0)
 coughing=1
end
 if player:worm():current_weapon():type():name() == "Yperit" and player:data().yperitammo < 1
 then player:data().yperitammo = player:data().yperitammo + 0.0017
end
 if player:worm():current_weapon():type():name() == "Yperit" and player:data().yperitammo >= 1
 and player:data().yperitreloaded == 0
 then player:worm():shoot(yperitdrawn, 1)
 player:data().yperitreloaded = 1
end
end

end

function jumpy.coughing(object)
coughing=0
end

function jumpy.yperitshoot(worm)
 if gascount <= 1 and worm:player():data().yperitammo >= 1
 then weapons.yperitshot(worm)
 worm:shoot(throw, 1)
 worm:player():data().yperitammo = 0
 worm:player():data().yperitreloaded = 0
  elseif worm:player():data().yperitammo >= 1 then
  worm:player():data().yperitpress = 1
end
end

function jumpy.gasdamage(object, worm)
worm:damage( 0.01, object:player() )
weapons.hit(object, worm)
if worm:player():data().gasmeter >= 240 and worm:player():data().gasmeter <= 254 and gameover == 0
then worm:player():data().gasmeter = worm:player():data().gasmeter + 0.02
end
if worm:player():data().gasmeter < 240 and gameover == 0
then worm:player():data().gasmeter = worm:player():data().gasmeter + 0.06
end
end

function jumpy.gasbegin(object)
gascount = gascount+1
end

function jumpy.gasend(object)
gascount = gascount-1
end

function jumpy.yperitrelease(worm)
 worm:player():data().yperitpress = 0
end

function jumpy.yperitdraw(worm)
 if worm:player():data().yperitammo >= 1 then
 worm:shoot(yperitdrawn, 1)
end
end

function jumpy.yperitskin(worm)
 if worm:player():data().yperitammo >= 1 and worm:current_weapon():type():name() == "Yperit" then
  if worm:angle() == 360 then worm:shoot(yperitskin2, 1, 0, 0, 0, 0, 0, 0)
  else worm:shoot(yperitskin, 1, 0, 0, 0, 0, 0, 0)
  end
 end
end

---JUMPING---

function bindings.localplayerEvent(player, event, state)
 local wx, wy = player:worm():pos()
 local wvx, wvy = player:worm():spd()
	
 if event == Player.Jump and state and player:worm():health() > 0 and player:data().hasdjumped == 0 
  and wvy < 0.8 and wvy > -0.45 and map_is_particle_pass(wx - 3, wy) and map_is_particle_pass(wx + 3, wy) and   map_is_particle_pass(wx, wy + 6) then
  player:worm():set_spd(1.2*wvx, wvy - 1.7)
  player:data().hasdjumped = 1
   if player:data().ismad == 0 then
    local sound = sounds["djump2.ogg"]
    local x,y = player:worm():pos()
    sound:play(x, y, 60, 1, 0.15)
   end
 end

 if event == Player.Jump and state and player:worm():health() > 0 and player:data().hasjumped == 0 then

  if not map_is_particle_pass(wx, wy + 6) and map_is_particle_pass(wx - 3, wy) and map_is_particle_pass(wx + 3, wy)
   and wvx > -0.2
   then
   player:worm():set_spd(1.1, wvy - 1.4)
   player:data().hasjumped = 1
   local sound = sounds["jump.ogg"]
   local x,y = player:worm():pos()
   sound:play(x, y, 140, 1, 0)
  end

  if not map_is_particle_pass(wx, wy + 6) and map_is_particle_pass(wx - 3, wy) and map_is_particle_pass(wx + 3, wy) 
   and wvx < 0.2
   then
   player:worm():set_spd(-1.1, wvy - 1.4)
   player:data().hasjumped = 1
   local sound = sounds["jump.ogg"]
   local x,y = player:worm():pos()
   sound:play(x, y, 140, 1, 0)
  end

  if not map_is_particle_pass(wx, wy + 6) and map_is_particle_pass(wx - 3, wy) and map_is_particle_pass(wx + 3, wy)
   and wvx <= 0.2 and wvx >= -0.2
   then
   player:worm():set_spd(wvx, wvy - 1.4)
   player:data().hasjumped = 1
   local sound = sounds["jump.ogg"]
   local x,y = player:worm():pos()
   sound:play(x, y, 120, 1, 0)
  end
 end
end

---KRAFT---

function jumpy.kraftpress(worm)
worm:player():data().kraftpress = 1
end

function jumpy.kraftrelease(worm)
worm:player():data().kraftrelease = 1
end

console_register_control("kraft", function(player, state)
if state == true then
weapons.kraftshooting(player) 
 if player == game_local_player(0) then
  local wtf = console["-P0_fire"]
 elseif player == game_local_player(1) then
  local wtf = console["-P1_fire"]
 end
end
end)

---BLOOD'n'GUTS---

function jumpy.blood(object)
local x, y = object:pos()
if not map_is_particle_pass(x-4, y+1) and not map_is_particle_pass(x+4, y+1)
and vector_distance( object:spd() ) > 0.1
then object:shoot(blooddown, 1)
end
if not map_is_particle_pass(x-4, y-1) and not map_is_particle_pass(x+4, y-1)
and vector_distance( object:spd() ) > 0.1
then object:shoot(bloodup, 1)
end
if not map_is_particle_pass(x-1, y+4) and not map_is_particle_pass(x-1, y-4)
and vector_distance( object:spd() ) > 0.1
then object:shoot(bloodleft, 1)
end
if not map_is_particle_pass(x+1, y+4) and not map_is_particle_pass(x+1, y-4)
and vector_distance( object:spd() ) > 0.1
then object:shoot(bloodright, 1)
end
end

function jumpy.left(object)
object:set_angle(90)
end

function jumpy.right(object)
object:set_angle(0)
end

function jumpy.guts(object)
 if vector_distance( object:spd() ) >= 0.5 then
 object:shoot(gutsound, 1)
end
 if vector_distance( object:spd() ) < 0.5 and vector_distance( object:spd() ) > 0.3 then
 object:shoot(gutsound2, 1)
end
 if vector_distance( object:spd() ) <= 0.3 and vector_distance( object:spd() ) > 0.15 then
 object:shoot(gutsound3, 1)
end
end

console_register_control("kill", function(player,state)
player:worm():damage(200, player)
end)


end

